c*********************************************************************
c
c                       ===============
c                       PROGRAM : CHRES
c                       ===============
c
c       This program can be used to change the resolution of the
c       2D spectra.  Everything is passed as command line arguments.
c
c       Usage:
c             chres [-n <nred>] <fn1> <fn2> .....
c                   <nred> : skip every nred points in the output
c
c*********************************************************************
c
      program chres
c
      implicit none
c
      include 'stdio.inc'
c
      integer i,j,n,ncalc,npt1,npt2,iend,idot,iargc,whris,narg,
     #        npt1o,npt2o,nred
      double precision inif1,inif2,res1,res2,amin,amax,res1o,res2o
c
      double precision spec(256,256)
c
      character*30 xaxis,yaxis,files(10),fileid,mgname,fout,args
      data xaxis/'f2 (MHz)'/
      data yaxis/'f1 (MHz)'/
c
      integer itoken
      external whris,iargc,getarg,itoken
c   
c#####################################################################
c
      nred=1
      narg=iargc()
      n=0
c
      if (narg.gt.0) then
         i=0
 5       i=i+1
         call getarg(i,args)
         if (args.eq.'-n') then
            i=i+1
            call getarg(i,args)
            nred=itoken( args )
            go to 5
         else
            n=n+1
            files(n)=args
         end if
         if (i.ne.narg) go to 5
      else
         write (luttyo,1000)
         call exit
      end if
c
      if (nred.eq.1) call exit
c
c======================================================================
c     loop over calculations
c======================================================================
c
      do 900 ncalc=1,n
c
         fileid=files(ncalc)
         iend=whris(fileid,' ')-1
         idot=whris(fileid,'.')
         if (idot.eq.0) then
            mgname=fileid(:iend)//'.spc'
            iend=iend+4
         else
            mgname=fileid(:iend)
         end if
c
         fout=mgname(:iend)//'1'
c
         do 25 i=1,256
         do 25 j=1,256
 25         spec(i,j)=0.0d0
c
         open (unit=ludisk,file=mgname,status='old',
     #        access='sequential',form='formatted')
         read (ludisk,*)
         read (ludisk,2110) npt2
         read (ludisk,2110) npt1
         read (ludisk,2120) inif2,res2,inif1,res1,amin,amax
         read (ludisk,2130) ((spec(i,j),j=1,npt2),i=1,npt1)
         close (unit=ludisk)
c
         res2o=res2*nred
         res1o=res1*nred
         npt2o=(npt2+1)/nred
         npt1o=(npt1+1)/nred
c
         open (unit=ludisk,file=fout,status='unknown',
     #         access='sequential',form='formatted')
         write (ludisk,3100) 0
         write (ludisk,3110) npt2o,1,npt2o,xaxis
         write (ludisk,3110) npt1o,1,npt1o,yaxis
         write (ludisk,3120) inif2,res2o,inif1,res1o,amin,amax
         write (ludisk,3120) ((spec(i,j),j=1,npt2,nred),i=1,npt1,nred)
         close (unit=ludisk)
c
c======================================================================
c     end of loop over calculations
c======================================================================
c
 900  continue
c
      stop
c
c=====================================================================
c     format statements
c=====================================================================
c
 1000 format(2x,'*** CHRES needs arguments ***')
c
 2110 format(i10)
 2120 format(6e10.4)
 2130 format(8e10.4)
c
 3100 format(i10)
 3110 format(3i10,5x,a30)
 3120 format(8e10.4)
 3130 format(2e10.4)
c
c=====================================================================
c
      end
