c*********************************************************************
c
c                       ================
c                       PROGRAM : EGSORT
c                       ================
c
c	This program sorts the eigenvalues.
c
c       Includes :
c               stddim.inc
c               stdio.inc
c               eprdat.inc
c               fnames.inc
c       Uses :
c               getids.f
c               rdfdat.f
c               indexx.f
c               whris.f
c
c*********************************************************************
c
      program egsort
c
      implicit none
c
      include 'stddim.inc'
      include 'stdio.inc'
      include 'eprdat.inc'
      include 'fnames.inc'
c
      logical fexist 
      integer i,j,n,ncalc,ierr,iend,ipsold,isort,indx(mxdim)
      double precision sarr(mxdim)
      complex*16 eval(mxdim),w(mxdim)
      character*30 egnams
c
      integer whris
      external whris
c
c#####################################################################
c
      write (luttyo,1000)
      write (luttyo,1010)
      write (luttyo,1020)
      read (luttyi,*) isort
c
      call getids(n,mxcalc)
c
c======================================================================
c     loop over calculations
c======================================================================
c
      do 900 ncalc=1,n
c
c---------------------------------------------------------------------
c     construct file names
c---------------------------------------------------------------------
c
      fileid = files(ncalc)
      ips=idxps(ncalc)
      iend = whris( fileid, ' ' )-1
c
      if(ips.eq.1) then
         prname=fileid(:iend)//'.parx'
         egname=fileid(:iend)//'.egvx'
         egnams=fileid(:iend)//'.egsx'
      else if (ips.eq.-1) then
         prname=fileid(:iend)//'.pary'
         egname=fileid(:iend)//'.egvy'
         egnams=fileid(:iend)//'.egsy'
      else
         prname=fileid(:iend)//'.parz'
         egname=fileid(:iend)//'.egvz'
         egnams=fileid(:iend)//'.egsz'
      end if
c
      namlth=iend+5
c
c----------------------------------------------------------------------
c     read in parameters from parameter file
c----------------------------------------------------------------------
c
      inquire(file=prname,exist=fexist)
c
      ipsold=ips      
      if (fexist) then
        call rdfdat(prname,ierr)
        ips=ipsold
      else
        write (luttyo,1100) prname(:namlth)
        go to 999
      endif
c
      if (ierr.ne.0) then
        write (luttyo,1120) prname(:namlth)
        go to 999
      end if
c
c----------------------------------------------------------------------
c     read in eigenvalues from file
c----------------------------------------------------------------------
c
      inquire(file=egname,exist=fexist)
      if (fexist) then
        open (unit=ludisk,file=egname,status='old',
     #        access='sequential',form='formatted')
        read (ludisk,2320) (j,indx(i),eval(i),w(i),i=1,ndim)
        close (unit=ludisk)
      else
        write (luttyo,1100) prname(:namlth)
        go to 999
      end if
c
      if (isort.eq.0) then
        do 201 i=1,ndim
 201      sarr(i)=dreal(eval(i))
      else if (isort.eq.1) then
        do 203 i=1,ndim
 203      sarr(i)=dimag(eval(i))
      else
        do 205 i=1,ndim
 205      sarr(i)=cdabs(w(i))
      end if
c
      call indexx(ndim,sarr,indx)
c
c---------------------------------------------------------------------
c     store the sorted eigenvalues into files
c---------------------------------------------------------------------
c
      open (unit=ludisk,file=egnams,status='unknown',
     #     access='sequential',form='formatted')
      if (isort.eq.0) then
        write (ludisk,2420) (ndim-i+1,indx(i),eval(indx(i)),
     #                       w(indx(i)),i=ndim,1,-1)
      else
        write (ludisk,2420) (i,indx(i),eval(indx(i)),w(indx(i)),
     #                       i=1,ndim)
      end if
      close (unit=ludisk)
c
 999  continue
c
c======================================================================
c     end of loop over calculations
c======================================================================
c
 900  continue
c
c---------------------------------------------------------------------
c     exit program
c---------------------------------------------------------------------
c
      stop
c
c=====================================================================
c     format statements
c=====================================================================
c
 1000 format(//,2x,70('#'),//)
 1010 format(25x,'PROGRAM : EGSORT',/,25x,'----------------',//)
 1020 format(2x,'Sort by Re(eval) (0), Im(eval) (1), Abs(wt) (2) ?',$)
 1100 format(/,20x,'*** CANNOT FIND FILE ',a,' ***',/)
 1120 format(/,20X,'*** ERROR READING PARAMETER FILE ',a,' ***',/)
c
 2320 format(i4,2x,i4,4x,g14.7,1x,g14.7,2x,g14.7,1x,g14.7)
 2420 format(i4,2x,i4,4x,g14.7,',',g14.7,2x,g14.7,',',g14.7)
c
c=====================================================================
c
      end
