c	VERSION	1.2 	9/27/91 modified by DEB
c***********************************************************************
c
c	Variable and common block definition for EPRLL and EPRLF families
c       of calculations.
c
c	Notes:
c		Any changes made to this file should also be made 
c		to the subroutines which read and write	this 
c		information to disk files.  See	the subroutines	
c		wrdat.f	and rddat.f (also wrfdat.f, wrrdat.f)
c
c   Extensively modified from original /eprdat/ by DEB 1/92
c    The following have been added:
c     wint0, wint2   (Line broadening params)
c     nelv           (number of vector elements)
c     ideriv         (derivative mode flag)
c     igsph,iasph    (spherical g,A tensor flags)
c     idrat          ("ratio" diffusion tensor flag)
c    *gad            (gamma Euler angle for diffusion tilt --alpha not needed)
c    *alm,blm,gam    (Euler angles of A tensor in g tensor frame)
c    *itm            (magnetic [i.e. A vs. g tensor] tilt flag}
c    *ips            (pS index: 1 or 0)
c    *jkmn           (minimum jK (K-symmetrization) index: -1 or 1)
c    *jmmn           (minimum jM (M-symmetrization) index: -1 or 1)
c    *lkmdff         (maximum difference for LKM truncation rule)
c    *lkmtrc         (LKM truncation rule flag)
c    *faa(5)         (ISTO elements of A-tensor in A-tensor frame)
c    *gamman         (nuclear gyromagnetic ratio (s^-1 G^-1) )
c    *zeen           (nuclear Zeeman in Gauss [normalized to electron freq.] )
c    %nev            (# of important eigenvectors)
c    %nevo           (# of important eigenvectors in off-diagonal space)
c    %ngood          (# of good eigenvalues)
c    %ndiag          (dimension of T-matrix used in the calculation of the
c                     eigenvalues)
c
c * indicates a quantity used only by EPRLF calculations
c % indicates a quantity used only by EPRP calculations
c
c  The following have been modified from the original /eprdat/ to permit
c  complex-valued ISTOs to be used in the EPRLF family of programs.
c     fam(5) changed to fam(2,5)
c     fgd(5) changed to fgd(2,5)
c     fad(5) changed to fad(2,5)
c
c  The relaxation constants are included in the following way.
c
c    %t2edi : 1/t2ed   rotationally invariant linewidth for e-transition
c    %t2ndi : 1/t2nd   rotationally invariant linewidth for n-transition
c    %t2efi : 1/t2ef   angular variation of linewidth, relevent to 
c               crystal or powder spectrum.  This can be regarded as
c		anisotropic Lorentzian inhomogeneous line-broadening
c    %t1edi : 1/t1e = 2*We 	electronic T1 relaxation
c    %t1ndi : 1/t1n = 2*Wn 	nuclear T1 relaxation
c
c***********************************************************************
c
	double precision gxx,gyy,gzz,axx,ayy,azz,dx,dy,dz,
     #			 tl,tkxy,tkzz,djf,djfprp,oss,psi,ald,bed,gad,
     #                   alm,bem,gam,c20,c22,c40,c42,c44,bshift,wint0,
     #			 wint2,b0,gamman,fieldi,fieldf,cgtol,shiftr,
     #                   shifti,a0,g0,zeen,pl,pkxy,pkzz,
     #                   t2edi,t2efi,t1edi,t2ndi,t1ndi,stvt1
c
	double precision faa,fgm,fam,fgd,fad,cxp,cpot,xlk,ptol,wtol
c
	integer	in2,ipdf,ist,itype,ideriv,igsph,iasph,idrat,
     #          lemx,lomx,kmx,mmx,ipnmx,ips,jkmn,jmmn,ngood,ndiag,
     #		nfield,nstep,mxcg,ipt,itd,itm,ipsi0,
     #          lband,kband,ldelta,kdelta,lkmdff,lkmtrc,lptmx,kptmx,
     #          ndim,ndimo,neltot,nelv,nelre,nelim
	integer	ixp,nev,nevo,nmev,int1,stt1,nstp,nort
c
	common /eprdat/	 gxx,gyy,gzz,axx,ayy,azz,dx,dy,dz,
     #	       tl,tkxy,tkzz,djf,djfprp,oss,psi,ald,bed,gad,
     #         alm,bem,gam,c20,c22,c40,c42,c44,bshift,
     #         wint0,wint2,b0,gamman,fieldi,fieldf,cgtol,
     #         shiftr,shifti,a0,g0,pl,pkxy,pkzz,zeen,cxp(6),
     #         cpot(5,5),xlk(5,5),faa(5),fgm(5),fam(2,5),
     #         fgd(2,5),fad(2,5),t2edi,t2efi,t1edi,t1ndi,t2ndi,
     #         ptol,wtol,ngood,ndiag,int1,stt1,nstp,
     #         in2,ipdf,ist,itype,ideriv,igsph,iasph,idrat,
     #         lemx,lomx,kmx,mmx,ipnmx,ips,jkmn,jmmn,nfield,nstep,
     #         mxcg,ipt,itd,itm,ipsi0,lband,kband,ldelta,kdelta,
     #         lkmdff,lkmtrc,lptmx,kptmx,ndim,ndimo,neltot,nelv,
     #         nevo,nev,nelre,nelim,ixp(6,2),nmev(10),nort

