c**********************************************************************
c
c                       ==================
c                       SUBROUTINE : FBASD
c                       ==================
c
c       This routine builds a list of the basis set indices for
c       diagonal space in common block /indexf/ for the
c       truncation parameters set in /eprdat/.
c       It is assummed that <fileid>.indx exists.  This file would
c       contain the pruned basis set after running through eprbf & prune.
c       The basis set indices for the off-diagonal space are read and
c       converted into the corresponding diagonal space.
c
c       Modified by DEB 13-MAR-93 from program EPRBAS by DJS
c       Modified by Sanghyuk Lee 1-DEC-92
c
c       Includes:
c               stddim.inc
c               stdio.inc
c               eprdat.inc
c               indexf.inc
c
c       Uses:
c               ipar.f
c
c**********************************************************************
c
      subroutine fbasd(ixname)
c
      implicit none
c
      include 'stddim.inc'
      include 'stdio.inc'
      include 'eprdat.inc'
      include 'indexf.inc'
c
      logical fexist
      character*30 ixname
      integer i,j,ilm
c
      double precision one,sqrt2
c
      integer ipar
      external ipar
c
c######################################################################
c
      one=1.0D0
      sqrt2=dsqrt(2.0D0)
c
      inquire(file=ixname,exist=fexist)
      if (fexist) then
        open (unit=ludisk,file=ixname,status='old',
     #        access='sequential',form='unformatted')
        read (ludisk) ndim
        read (ludisk) (pi1(i),qi1(i),l1(i),jk1(i),k1(i),
     #                 jm1(i),m1(i),i=1,ndimo)
        close (unit=ludisk)
c
c----------------------------------------------------------------------
c       convert pruned off-diagonal basis set into diagonal one.
c----------------------------------------------------------------------
c
        j=0
        do 100 i=1,ndimo
          j=j+1
          dl1(j)=l1(i)
          djk1(j)=jk1(i)
          dk1(j)=k1(i)
          djm1(j)=0
          dm1(j)=m1(i)
          djqe1(j)=jm1(i)
          dpi1(j)=pi1(i)
          dqi1(j)=qi1(i)
          pid(i)=1
          if ((pi1(i).eq.0).and.(m1(i).eq.0)) then
            pp(j)=sqrt2
          else
            pp(j)=one
c
            j=j+1
            dl1(j)=l1(i)
            djk1(j)=jk1(i)
            dk1(j)=k1(i)
            djm1(j)=0
            dm1(j)=-m1(i)
            djqe1(j)=jm1(i)
            dpi1(j)=-pi1(i)
            dqi1(j)=qi1(i)
            pid(i)=2
            ilm=ipar(l1(i)+m1(i))
            if (ilm.eq.jm1(i)) then
              pp(j)=one
            else
              pp(j)=-one
            end if
          end if
 100    continue
        ndim=j
c
      else
        write (luttyo,1000)
        call exit
      end if
c
      return
c
 1000 format (2x,'##### BASIS INDEX FILE FOR OFF-DIAGONAL DOES NOT',
     #        ' EXIST #####')
c
      end
