c----------------------------------------------------------------------
c                    =========================
c                       subroutine GETIDT
c                    =========================
c
c  Returns filenames necessary for generating 2-D spectrum in arrays
c  in common /tdfile/.
c  Optionally uses UNIX command line parameter convention
c
c     n        ; # of files
c     narg     ; # of arguments
c
c     flags    :
c
c           -t generate dual quadrature (DQ) time domain signal (t1,t2)
c           -f use DQ time domain signal (t1,t2) for PROC2D program
c           -e <fileid for result of eigenvector calculation>
c           -r write eigenvalues in <id>.trm for MOMD program
c           -d <fileid> or <fileid>  ; use same id for all the files
c
c  Uses :
c	   whris.f  ;  subroutine that replaces index (Unix command)
c----------------------------------------------------------------------
      subroutine getidt(n,limit)
c
      implicit none
c
      integer n,limit
c
      include 'tddim.inc'
      include 'stdio.inc'
      include 'tdexp.inc'
      include 'tdfnam.inc'
c
c...............................................
c Code between dotted lines is intended for 
c running these programs in a UNIX environment
c
      integer i,idot,ineg,narg,itok,jtok,ihlp
      character*30 args
      character*1 chr
c
      integer iargc,whris
      external iargc,getarg,whris
c
      itimed=0
      imag=0
      irec=0
      n=0
      itok=0
      jtok=0
      narg=iargc()
c
      if (narg.gt.0) then
         do 5 i=1,narg
           call getarg(i,args)
           ihlp=whris(args,'?')
           if ((i.eq.1).and.(ihlp.gt.0)) then
               write(luttyo,1000)
               call exit
           end if
           idot=whris(args,'.')
           if (idot.gt.0) then
               write(luttyo,1010)
               call exit
           end if
 5       continue
c
         i=0
 10      i=i+1
         if (i.gt.limit) return
         call getarg(i,args)
         ineg=whris(args,'-')
         if (ineg.eq.0) then
             n=n+1
             if (jtok.eq.0) iofile(n)=args
             if (itok.eq.0) dtfile(n)=args
         else if (ineg.eq.1) then
             chr=args(2:2)
             if ((chr.eq.'e').or.(chr.eq.'E')) then
                 i=i+1
                 call getarg(i,args)
                 dtfile(n+1)=args
                 itok=1
                 go to 10
             else if ((chr.eq.'f').or.(chr.eq.'F')) then
                 i=i+1
                 call getarg(i,args)
                 iofile(n+1)=args
                 jtok=1
                 imag=1
                 go to 10
             else if ((chr.eq.'d').or.(chr.eq.'D')) then
                 itok=0
                 go to 10
             else if ((chr.eq.'r').or.(chr.eq.'R')) then
                 irec=1
                 go to 10
             else if ((chr.eq.'t').or.(chr.eq.'T')) then
                 itimed=1
                 go to 10
             else
                 write (luttyo,1020)
                 call exit
             end if
         else
             write (luttyo,1030)
             call exit
         end if
         if (i.ne.narg) go to 10
      else
c..................................................
c
 20     n=n+1
 25     write (luttyo,1040)
        read (luttyi,1045,err=25) iofile(n)
        if (iofile(n).eq.' ') then
            n=n-1
            return
        end if
        idot=whris(iofile(n),'.')
        if(idot.gt.0) then
           write (luttyo,1010)
           go to 25
        end if
c
 30     write (luttyo,1050)
        read (luttyi,1045,err=30) dtfile(n)
        idot=whris(dtfile(n),'.')
        if(idot.gt.0) then
           write (luttyo,1010)
           go to 30
        end if
c 
        if (n.lt.limit) go to 20
c
      end if
c..................................................
c
      return
c
c######################################################################
c  Format statements
c######################################################################
c
 1000 format(2x,' *** eprps [-t] [-e <egvid>] <inpid1>',
     #      '  [-d <inpid2>]',/,5x,'-t : time domain signal',
     #      /,5x,'-e <egvid> : fileid for eigen solutions',
     #      /,5x,'-d <inpid> : fileid for 2D input file is the',
     #      ' same as <egvid>',/,18x,'*default mode*')
 1010 format(2x,' *** No extension in the file name *** ')
 1020 format(2x,' *** Invalid flag (Valid flags : -e, -d) *** ')
 1030 format(2x,' *** Wrong position of flag *** ')
 1040 format(2x,'Enter file id for .inp (<CR> to end): ')
 1045 format(a)
 1050 format(2x,'Enter file id for .egv  : ')
      end
