c*********************************************************************
c
c                       ===============
c                       PROGRAM : NCONT
c                       ===============
c
c       This program can be used to generate the normalized contours or
c       to store only part of the spectrum.
c
c*********************************************************************
c
      program ncont
c
      implicit none
c
      include 'stdio.inc'
c
      logical prmpt,fprmpt
      character*80 line
      logical zflag
c
      integer i,j,k,n,limit,inct,ncalc,npt1,npt2,n1i,n2i,n1f,n2f,
     #        n1z,ntmp,iend,idot,iargc,whris,narg,npt1h,nbnd,npt1o
      double precision f1,f1i,f1f,inif1,res1,amin,amax,acut,aratio,
     #        zmin,zmax,f2,f2i,f2f,inif2,res2,tmp
c
      double precision zero,rndff,spec(256,256),zslice(256)
      parameter (limit=10,zero=0.0D0,rndff=1.0d-15)
c
      character*30 xaxis,yaxis,files(10),fileid,mgname,ncname,
     #             zsname,args
      data xaxis/'f2 (MHz)'/
      data yaxis/'f1 (MHz)'/
c
      integer itoken
      double precision ftoken
      external whris,iargc,getarg,prmpt,itoken,ftoken
c   
c#####################################################################
c
      write (luttyo,1000)
      write (luttyo,1010)
c
      narg=iargc()
      n=0
      zflag=.false.
c
      if (narg.gt.0) then
         do 5 i=1,narg
            call getarg(i,args)
            if (args.eq.'-z') then
               zflag=.true.
               go to 5
            else
               n=n+1
               files(n)=args
            end if
 5       continue
      else
 10      n=n+1
 15      write (luttyo,1020)
         read (luttyi,1025,err=15) files(n)
         if (files(n).eq.' ') then
            n=n-1
            go to 20
         end if
         if (n.lt.limit) go to 10
      end if
c
 20   continue
c
      inct=1
      if (.not.zflag) then
         write (luttyo,1100) inct
         fprmpt=prmpt(line)
         if (fprmpt) inct=itoken( line )
      end if
c
      f1i=-5.D1
      f1f=5.D1
      f2i=-1.D2
      f2f=1.D2
      write (luttyo,1110) f1i,f1f,f2i,f2f
      fprmpt=prmpt(line)
      if (fprmpt) then
         f1i=ftoken( line )
         f1f=ftoken( line )
         f2i=ftoken( line )
         f2f=ftoken( line )
      end if
c
      if (inct.eq.1) then
         aratio=5.0d-2
         write (luttyo,1120) aratio
         fprmpt=prmpt(line)
         if (fprmpt) aratio=ftoken( line )
      end if
c
c======================================================================
c     loop over calculations
c======================================================================
c
      do 900 ncalc=1,n
c
         fileid=files(ncalc)
         iend=whris(fileid,' ')-1
         idot=whris(fileid,'.')
         if (idot.eq.0) then
            mgname=fileid(:iend)//'.spc'
            ncname=fileid(:iend)//'.nct'
            zsname=fileid(:iend)//'.zms'
         else
            mgname=fileid(:iend)
            ncname=fileid(:idot)//'nct'
            zsname=fileid(:idot)//'zms'
         end if
c
         write (luttyo,5000) ncalc,fileid(:iend)
c                              * zero out the array
         do 25 i=1,256
         do 25 j=1,256
 25         spec(i,j)=zero
c
         open (unit=ludisk,file=mgname,status='old',
     #        access='sequential',form='formatted')
         read (ludisk,*)
         read (ludisk,2110) npt2
         read (ludisk,2110) npt1
         read (ludisk,2120) inif2,res2,inif1,res1,amin,amax
         read (ludisk,2130) ((spec(i,j),j=1,npt2),i=1,npt1)
         close (unit=ludisk)
c
         acut=aratio*amax
c
         npt1o=npt1
         n1i=0
         n1f=0
         n2i=0
         n2f=0
         n1z=0
c
c-----------------------------------------------------------------------
c       search for display range for f1
c-----------------------------------------------------------------------
c                              * starting point
         if (f1i.lt.inif1) then
c throw away first point (somehow works more stable)       
            n1i=2
         else
            i=0
 30         i=i+1
            f1=inif1+res1*(i-1)
            if ((f1-f1i).lt.rndff) go to 30
            n1i=i
         end if
c                              * zero-crossing point
         i=0
 31      i=i+1
         f1=inif1+res1*(i-1)
         if (f1.lt.rndff) go to 31
         if ((-f1+res1).lt.f1) then
            n1z=i-1
         else
            n1z=i
         end if
c                              * end point
         i=0
 32      i=i+1
         f1=inif1+res1*(i-1)
         if ( ((f1-f1f).lt.rndff) .and. (i.lt.npt1) ) go to 32
         n1f=i-1
c
         inif1=inif1+res1*(n1i-1)
c
c-----------------------------------------------------------------------
c       search for range for f2
c-----------------------------------------------------------------------
c                              * starting point
         if (f2i.lt.inif2) then
            n2i=2
         else
            i=0
 40         i=i+1
            f2=inif2+res2*(i-1)
            if ((f2-f2i).lt.rndff) go to 40
            n2i=i
         end if
c                              * end point
         i=0
 42      i=i+1
         f2=inif2+res2*(i-1)
         if ( ((f2-f2f).lt.rndff) .and. (i.lt.npt2) ) go to 42
         n2f=i-1
c
         inif2=inif2+res2*(n2i-1)
c
c-----------------------------------------------------------------------
c       calculated the normalized contour and store in the file
c-----------------------------------------------------------------------
c
         npt1=n1f-n1i+1
         npt2=n2f-n2i+1
c
         if (inct.eq.1) then
            npt1h=npt1/2
c make # of data points along f1 axis as odd #
            if (npt1.eq.2*npt1h) then
               n1f=n1f-1
               npt1=npt1-1
               npt1h=npt1h-1
            end if
c
            do 200 j=n2i,n2f
c search for maximum peak height
               tmp=zero
               do 210 k=n1i,n1f
                  if (spec(k,j).gt.tmp) then
                     ntmp=k
                     tmp=spec(k,j)
                  end if
 210           continue
c normalize the slice
               zslice(j)=tmp
               do 220 k=1,npt1o
                  if (spec(k,j).lt.acut) then
                     spec(k,j)=zero
                  else
                     spec(k,j)=spec(k,j)/tmp
                  end if
 220           continue
c take average of the two data points around peak maximum to get
c symmetric shape in the normalized contour plot.
               nbnd=min(n1f-ntmp,ntmp-n1i)
               do 225 k=1,nbnd
                  tmp=(spec(ntmp+k,j)+spec(ntmp-k,j))*0.5D0
                  spec(ntmp+k,j)=tmp
                  spec(ntmp-k,j)=tmp
 225           continue
c shift the spectrum so that peak maximum appears along f1=0
               ntmp=ntmp-(n1i+npt1h)
               if (ntmp.gt.0) then
                  do 230 k=n1i,n1f
 230                 spec(k,j)=spec(k+ntmp,j)
               else if (ntmp.lt.0) then
                  do 240 k=n1f,n1i,-1
 240                 spec(k,j)=spec(k+ntmp,j)
               end if
 200        continue
         end if
c
c---------------------------------------------------------------------
c       Preparation of graph (Frequencies in MHz)
c---------------------------------------------------------------------
c
         amin=zero
         amax=zero
         zmin=1.0D15
         zmax=zero
         do 310 j=n2i,n2f
            if( zslice(j).gt.zmax ) zmax=zslice(j)
            if( zslice(j).lt.zmin ) zmin=zslice(j)
            do 310 i=n1i,n1f
               if( spec(i,j).gt.amax ) amax=spec(i,j)
               if( spec(i,j).lt.amin ) amin=spec(i,j)
310      continue
c
         open (unit=ludisk,file=ncname,status='unknown',
     #         access='sequential',form='formatted')
         write (ludisk,3100) 0
         write (ludisk,3110) npt2,1,npt2,xaxis
         write (ludisk,3110) npt1,1,npt1,yaxis
         write (ludisk,3120) inif2,res2,inif1,res1,amin,amax
         write (ludisk,3120) ((spec(i,j),j=n2i,n2f),i=n1i,n1f)
         close (unit=ludisk)
c
         if (zflag) then
c         inif2=inif2+res2*(npt2-1)
c
            open (unit=ludisk,file=zsname,status='unknown',
     #            access='sequential',form='formatted')
            write (ludisk,3100) 0
            write (ludisk,3100) npt2
            write (ludisk,3130) inif2,res2
            write (ludisk,3130) zmin,zmax
            write (ludisk,3120) (zslice(i),i=n2i,n2f)
            close (unit=ludisk)
         end if
c
c======================================================================
c     end of loop over calculations
c======================================================================
c
 900  continue
c
      stop
c
c=====================================================================
c     format statements
c=====================================================================
c
 1000 format(//,2x,70('#'),//)
 1010 format(25x,'PROGRAM : NCONT',/,25x,'---------------',//)
 1020 format(2x,'Enter filename with extension (<CR> to end):  ')
 1025 format(a)
c
 1100 format(2x,'Normalized contours (1) or Partial spectrum (2)',
     #       '? :  ',i1)
 1110 format(2x,'Enter freq. range of f1 & f2 :',4(1x,f8.2))
 1120 format(2x,'Enter cut-off ratio :',g12.3)
c
 2110 format(i10)
 2120 format(6e10.4)
 2130 format(8e10.4)
c
 3100 format(i10)
 3110 format(3i10,5x,a30)
 3120 format(8e10.4)
 3130 format(2e10.4)
c
 5000 format(15x,39('='),/,
     #     15x,'Calculation no. ',I2,' using file ',a,/,
     #     15x,39('='),/)
c
c=====================================================================
c
      end
