c**********************************************************************
c       
c                       ==============
c                       PROGRAM : TDIP
c                       ==============
c
c       (T)wo (D)imensional (I)nput (P)arameters
c
c       This program will prompt the user to enter the input parameters 
c       required to calculate the 2-D spectrum.
c
c       written by Sanghyuk Lee
c
c       Includes:
c               tddim.inc
c               stdio.inc
c               rndoff.inc
c               tdfnam.inc
c               eprdat.inc
c               tdexp.inc
c       Uses:
c               getidt.f
c               tdsnam.f
c               prmpt.f
c               rdfdat.f
c               rdfinp.f
c               wrfinp.f
c
c**********************************************************************
c
      program tdip
c
      implicit none
c
      include 'tddim.inc'
      include 'stdio.inc'
      include 'rndoff.inc'
      include 'tdfnam.inc'
      include 'eprdat.inc'
      include 'tdexp.inc'
c
      character*80 line
c
      integer nfiles,itoken,mxcal,ierr
      double precision ftoken
      logical fexist,fprmpt,prmpt
      external prmpt,itoken,ftoken
c
c######################################################################
c
      write (luttyo,1000)
      write (luttyo,1010) 
c
      mxcal=10
      call getidt(nfiles,mxcal)
      ioflid = iofile(1)
      dtflid = dtfile(1)
      call tdsnam
c
c----------------------------------------------------------------------
c     check for existence and open parameter file
c----------------------------------------------------------------------
c
      inquire(file=prnamx,exist=fexist)
      if (fexist) then
        write (luttyo,1040) prnamx(:namlth)
        call rdfdat(prnamx,ierr)
      end if
c
      inquire(file=ipname,exist=fexist)
      if (fexist) then
        write (luttyo,1040) ipname(:namlth)
        call rdfinp(ipname)
      end if
c
      field=b0
      ndim1=ndim
      if (nev1.eq.0) nev1=nev
c
c----------------------------------------------------------------------
c     get experimental type
c----------------------------------------------------------------------
c
 11   write (luttyo,2000) iexp
      fprmpt=prmpt(line)
      if (fprmpt) iexp=itoken(line)
      if ( (iexp.lt.0) .or. (iexp.gt.5) ) go to 11
c
      if (iexp.eq.0) then
        icomb=1
      else
 12     write (luttyo,2005) icomb
        fprmpt=prmpt(line)
        if (fprmpt) icomb=itoken(line)
        if ( (icomb.eq.1).and.((iexp.eq.2).or.(iexp.eq.4).or.
     #       (iexp.eq.5)) ) then
          write (luttyo,2006)
          go to 12
        end if
      end if
c
c----------------------------------------------------------------------
c     get information for the 2-D plot
c----------------------------------------------------------------------
c
 13   write (luttyo,2010) npt1,npt2
      fprmpt=prmpt(line)
      if (fprmpt) then
        npt1=itoken(line)
        npt2=itoken(line)
      end if
c
      if ((nort.gt.1).and.((npt1.gt.256).or.(npt2.gt.256))) then
        write (luttyo,2015)
        go to 13
      end if
c
 14   write (luttyo,2020) idtf,ispc
      fprmpt=prmpt(line)
      if (fprmpt) then
        idtf=itoken(line)
        ispc=itoken(line)
      end if
      if ((idtf.lt.0) .or. (idtf.gt.2)) go to 14
      if ((iexp.eq.0).and.(ispc.eq.1)) go to 14
      if ((idtf.gt.0).and.((iexp.eq.2).or.(iexp.eq.4))) then
c    **  echo-exp. needs the transformation (t1,t2) --> (t1,t1+t2)
          write (luttyo,2025)
      end if
      if (ispc.lt.idtf) then
c    **  freq. signal from time domain signal is not active option yet.
          write (luttyo,2027)
          go to 14
      end if
c
      if ((itimed.eq.1).and.(idtf.ne.0)) then
        write (luttyo,2027)
        idtf=0
      end if
c
      if (idtf.eq.0) then
        write (luttyo,2030) init1,stpt1,init2,stpt2
        fprmpt=prmpt(line)
        if (fprmpt) then
          init1=ftoken(line)
          stpt1=ftoken(line)
          init2=ftoken(line)
          stpt2=ftoken(line)
        end if
      else if (idtf.eq.1) then
        write (luttyo,2033) init1,stpt1,inif2,finf2
        fprmpt=prmpt(line)
        if (fprmpt) then
          init1=ftoken(line)
          stpt1=ftoken(line)
          inif2=ftoken(line)
          finf2=ftoken(line)
        end if
      else
        write (luttyo,2035) inif1,finf1,inif2,finf2
        fprmpt=prmpt(line)
        if (fprmpt) then
          inif1=ftoken(line)
          finf1=ftoken(line)
          inif2=ftoken(line)
          finf2=ftoken(line)
        end if
      end if
c
      if (iexp.eq.0) then
        npt2=1
        init2=0.0D0
        stpt2=0.0D0
        inif2=0.0D0
        finf2=0.0D0
      end if
c
c----------------------------------------------------------------------
c     get the input parameters according to the experiment type
c----------------------------------------------------------------------
c
      if (iexp.gt.2) then
        write (luttyo,2040) tfix
        fprmpt=prmpt(line)
        if (fprmpt) tfix=ftoken(line)
      end if
c
      if (nort.gt.1) then
        nev0=0
        nev1=0
        go to 32
      end if      
c
c----------------------------------------------------------------------
c     get the number of eigenvalues to be included in the calculation
c----------------------------------------------------------------------
c
 21   if (iexp.lt.3) then
        write (luttyo,2055) nev1
        fprmpt=prmpt(line)
        if (fprmpt) nev1=itoken(line)
        if (nev1.eq.0) go to 21
      else
        inquire(file=prnamz,exist=fexist)
        if (fexist) call rdfdat(prnamz,ierr)
        if (nev0.eq.0) nev0=nev
        write (luttyo,2065) nev1,nev0
        fprmpt=prmpt(line)
        if (fprmpt) then
          nev1=itoken(line)
          nev0=itoken(line)
        end if
        if ( (nev1.eq.0).or.(nev0.eq.0)) go to 21
      end if
c
c----------------------------------------------------------------------
c     get flag for Nuclear Zeeman term
c----------------------------------------------------------------------
c
32    write (luttyo,2070) inz
      fprmpt=prmpt(line)
      if (fprmpt) inz=itoken(line)
c
c----------------------------------------------------------------------
c     get Gaussian inhomogeneous broadening
c----------------------------------------------------------------------
c
      write (luttyo,2110) gib0,gib2
      fprmpt=prmpt(line)
      if (fprmpt) then
        gib0=ftoken(line)
        gib2=ftoken(line)
      end if
c
      if (gib0.lt.rndoff) gib0=0.0D0
      if (gib2.lt.rndoff) gib2=0.0D0
      if ((nort.le.1).and.(gib2.gt.rndoff)) then
        write(luttyo,2120)
        gib2=0.0D0
      end if
      if ((idtf.ne.0).and.((gib0.gt.rndoff).or.(gib2.gt.rndoff))) then
        write(luttyo,2130)
      end if
c
      write (luttyo,2200) lwid
      fprmpt=prmpt(line)
      if (fprmpt)  lwid=ftoken(line)
      if (lwid.lt.rndoff)  lwid=0.0D0
c 
c----------------------------------------------------------------------
c     write new parameters to a formatted disk file (used by EPRPS)
c----------------------------------------------------------------------
c
      call wrfinp(ipname,namlth)
c
      call rdfdat(prnamx,ierr)
      if (idtf.le.1) then
        int1=init1 
        stt1=stpt1
        nstp=npt1
      end if
      call wrfdat(prnamx)
c
      stop
c
c======================================================================
c               format statements
c======================================================================
c
 1000 format(//,2x,70('#'),/)
 1010 format(25x,'PROGRAM : TDIP',/,25x,'--------------',/)
 1040 format(2x,'*** Data file ',a,' already exists on the disk***')
c
 2000 format(2x,'Experimental Type [iexp] : ',i2,/,
     #    10x,'iexp=0 --> 1D-FID         ; (90-t1)',/,
     #    10x,'iexp=1 --> 2D-COSY        ; (90-t1-90-t2)',/,
     #    10x,'iexp=2 --> 2D-SECSY       ; (90-t1-90-t1-t2)',/,
     #    10x,'iexp=3 --> 2D-ELDOR       ; (90-t1-90-T-90-t2)',/,
     #    10x,'iexp=4 --> 2D-ECHO ELDOR  ; (90-t1-90-T-90-t1-t2)',/,
     #    10x,'iexp=5 --> 2D-STIM. SECSY ; (90-T-90-t1-90-T-t2)')
 2005 format(2x,'Spectral Combination [icomb] : ',i2,/,
     #    10x,'icomb=-1 --> Sc-  ; icomb=1 --> Sc+')
 2006 format(2x,'*** Sc+ for echo exp. : Are you sure? ***')
 2010 format(2x,'# of data points in (t1,t2) [npt1,npt2] : ',i3,2x,i3)
 2015 format(2x,'** Reduce data points (max=256 for MOMD) **')
 2020 format(2x,'Calculation and output type [idtf,ispc] : ',i2,2x,i2,
     #    /,10x,'0 --> (t1,t2) ; 1 --> (t1,f2) ; 2 --> (f1,f2)')
 2025 format(2x,'*** freq. domain calc. for echo experiment only',
     #       ' valid for FS-ESE')
 2027 format(2x,'*** Inverse FT (freq. to time) is not ',
     #       'implemented yet',/,6x,'Time domain calculation is ',
     #       'assumed')
 2030 format(2x,'Initial and step in t1 & t2 [init1,stpt1,init2,',
     #    'stpt2] (ns) : ',/,t20,g13.6,3(3x,g13.6))
 2033 format(2x,'Initial and step t1 & initial and final in f2',
     #    ' [init1,stpt1,inif2,finf2] (MHz) : ',/,t20,
     #    g13.6,3(3x,g13.6))
 2035 format(2x,'Initial and final in f1 & f2 [inif1,finf1,inif2,',
     #    'finf2] (MHz) : ',/,t20,g13.6,3(3x,g13.6))
 2040 format(2x,'Fixed time [tfix] (ns) = ',g13.6)
 2055 format(2x,'# of significant eigenvalues in pS=1',
     #     ' subspace [nev1] : ',i4)
 2065 format(2x,'# of sig. egvalues in pS=1, 0',
     #     ' subspace [nev1,nev0] : ',i4,2x,i4)
 2070 format(2x,'Include nuclear Zeeman? (Y=1/N=0) : ',i1)
c
 2110 format(2x,'GIB width [gib0,gib2] (gauss) = ',g13.6,2x,g13.6)
 2120 format(2x,'*** gib2 is assumed to be zero not for MOMD ***')
 2130 format(2x,'*** GIB in frequency domain only for FS-ESE. ***')
c
 2200 format(2x,'Homogeneous line-width [lwid] (gauss) = ',g13.6)
c
c======================================================================
c
      end
