c       VERSION 1.2     3/13/92
c**********************************************************************
c
c                       ===================
c                       SUBROUTINE : WRFBAS
c                       ===================
c
c       This routine lists the basis set indices contained in common
c       /indexf/ to the specified logical output unit. It is assumed
c       that subroutine fbaso has been called prior to calling this
c       routine, which is primarily designed to be called by lblf.f.
c
c       Modified by DEB 13-MAR-93 from program EPRBAS by DJS
c
c       Includes:
c               stddim.inc
c               eprdat.inc
c               indexf.inc
c
c       Uses:
c               ipar.f
c
c**********************************************************************
c
      subroutine wrfbas(prname,lth,lu)
c
      include 'stddim.inc'
      include 'eprdat.inc'
      include 'indexf.inc'
c
      character*30 prname
      integer lu,lth,i
c
c######################################################################
c
      write(lu,1050) prname(:lth)
      write(lu,1060)
c
      if (ips.ne.0) then
        do 10 i=1,ndim
          write(lu,1070) i,l1(i),jk1(i),k1(i),jm1(i),m1(i),
     #                   pi1(i),qi1(i)
 10     continue
      else
        do 20 i=1,ndim
          write(lu,1070) i,dl1(i),djk1(i),dk1(i),djqe1(i),dm1(i),
     #                   dpi1(i),dqi1(i)
 20     continue
      end if
c
      write(lu,1080) ndim
      write(lu,1090) ptol
      write(lu,1000)
c
      return
c
c======================================================================
c     format statements
c======================================================================
c
 1000 format(//,2x,70('#'),//)
 1050 format(//,2x,70('#'),///,28x,'file : ',a,/,
     #     28x,16('-'),//)
 1060 format(/,15x,'BASIS SET',//,2x,'element',7x,'L  jK   K',
     #     '  jqM  M  pI  qI',/,2x,42('-'))
 1070 format(4x,i5,4x,'|',6(i3,','),i3,'  >')
 1080 format(/,2x,'The dimension of the matrix is : ',i5)
 1090 format(/,2x,'The tolerance of pruning is : ',g12.5)
c
c======================================================================
c
      end
