c***********************************************************************
c
c                       ===============
c                       program FEGVEC1
c                       ===============
c
c       This program will read in the eigen vectors data file 
c       written by eprlf and write it into a formatted file in
c       an understandable form.
c       This is meant to write only part of the eigenvectors,
c       not the whole vectors to reduce the storage space.
c
c       Includes:
c               stddim.inc
c               stdio.inc
c               eprdat.inc
c               indexf.inc
c               fnames.inc
c               rndoff.inc
c
c       Uses:
c               getids.f
c               setnam.f
c               rdfdat.f
c               fbaso.f
c               fbasd.f
c
c***********************************************************************
c
      program fegvec1
c
      include 'stddim.inc'
      include 'stdio.inc'
      include 'eprdat.inc'
      include 'indexf.inc'
      include 'fnames.inc'
      include 'rndoff.inc'
c
      integer i,j,k,ierr,ians
      complex*16 egval(xdim),wt(xdim),oomat(xdim,xdim)
c
c######################################################################
c
      write (luttyo,1000)
      write (luttyo,1010)
c
c----------------------------------------------------------------------
c     get file identifier and construct file names
c----------------------------------------------------------------------
c
      call getids(n,1)
c
      fileid=files(1)
      ips=idxps(1)
c
      call setnam
c
c----------------------------------------------------------------------
c     read in data from parameter file
c----------------------------------------------------------------------
c
      call rdfdat(prname,ierr)
      if (ndim.gt.xdim) then
        write (luttyo,2000) ndim,xdim
        stop
      end if
c
      if (ips.ne.0) then
        call fbaso(ixname)
      else
        call fbasd(ixname)
        do 50 i=1,ndim
 50       jm1(i)=jqe1(i)
      end if
c       
c----------------------------------------------------------------------
c     read in eigenvalues and eigenvectors
c----------------------------------------------------------------------
c
      if (nev.eq.0) nev=ndim
c
      open (unit=ludisk,file=egname,status='old',
     #     access='sequential',form='formatted')
      read (ludisk,2320) (j,k,egval(i),wt(i),i=1,nev)
      close (unit=ludisk)
c
      open (unit=ludisk,file=evname,status='old',
     #      access='sequential',form='unformatted')
      do 10 j=1,nev
        read (ludisk) (oomat(i,j),i=1,ndim)
 10   continue
      close (unit=ludisk)
c
      if (ips.eq.-1) then
         write (luttyo,1020)
         read (luttyi,*) ians
         if (ians.eq.1) then
            do 15 j=1,nev
               egval(j)=dconjg(egval(j))
               wt(j)=dconjg(wt(j))
               do 16 i=1,ndim
                  oomat(i,j)=dconjg(oomat(i,j))
 16            continue
 15         continue
         end if
      end if
c
      do 18 j=1,nev
         if (real(oomat(1,j)).lt.0) then
            do 19 i=1,ndim
               oomat(i,j)=-oomat(i,j)
 19         continue
         end if
 18   continue
c
c----------------------------------------------------------------------
c     read the range of eigenvectors to output
c----------------------------------------------------------------------
c
      write (luttyo,1025) ndim
      read (luttyi,*) irow,frow
c
c----------------------------------------------------------------------
c     write out elements of eigenvalues and eigenvectors
c----------------------------------------------------------------------
c
      open (unit=ludisk,file=efname,status='unknown',
     #     access='sequential',form='formatted')

      write (ludisk,1000)
      write (ludisk,1030) egname(:namlth)
      write (ludisk,1040) evname(:namlth)
c
      do 20 j=irow,frow
      write (ludisk,1050) j,egval(j),wt(j)
      write (ludisk,1060) 
c
      do 40 i=1,ndim
        if (cdabs(oomat(i,j)).gt.rndoff) 
     #   write (ludisk,1070) i,dreal(oomat(i,j)),dimag(oomat(i,j)),
     #        l1(i),jk1(i),k1(i),jm1(i),m1(i),pi1(i),qi1(i)
 40   continue
 20   continue
c
c----------------------------------------------------------------------
c     exit program
c----------------------------------------------------------------------
c
      write (ludisk,1000)
      stop
c
c======================================================================
c     format statements
c======================================================================
c
 1000 format (//,70('#'),/)
 1010 format (25x,'PROGRAM : FEGVEC1',/,25x,'----------------',/)
 1020 format (2x,'Take complex conjugate for eigenvalues and eigen',
     #        'vectors? (1=yes)')
 1025 format (/,10x,'Range of eigenvectors (1,',i3,') : ')
 1030 format (/,10x,'eigenvalues from file : ',a)
 1040 format (/,10x,'eigenvector elements from file : ',a)
 1050 format (//,' *** ',i3,' : ','(',g14.7,',',
     #        g14.7,')',2x,'(',g14.7,',',g14.7,')')

 1060 format (/,3x,'Row',3x,'Real Part',6x,'Imaginary Part',6x,
     #        'L  jK   K  jqM  M  pI  qI',/)
 1070 format (1x,i5,' (',g14.7,',',g14.7,')   ',
     # '|',6(i3,','),i3,'>')
 2000 format (/,10x,'*** DIMENSION (',i4,') larger than maximum (',
     # i4,')')
 2320 format(i4,2x,i4,4x,g14.7,1x,g14.7,2x,g14.7,1x,g14.7)

c
c======================================================================
c
      end 
