c----------------------------------------------------------------------
c                   =========================
c                      common block TDFNAM
c                   =========================
c
c Common block for all the filenames that may possible be associated
c with a given file i.d.  The filenames are defined as follows:
c 
c      ipname : <ioflid>.INP   Input parameter file for 2-D
c                              experiment (formatted)
c      rpname : <ioflid>.TRM   messages from the program
c      mgname : <ioflid>.MAG   2-D magnitude spectrum (formatted)
c      fidnam : <ioflid>.FID   2-D spectrum in (t1,t2) (unformatted)
c      gibnam : <ioflid>.GIB   2-D spectrum in (t1,t2) (unformatted)
c                              with inhomogeneous broadening
c      datnam : <ioflid>.DAT   Dual quadrature 2-D spectrum in (t1,t2)
c                              (unformatted)
c      prnamx : <dtflid>.PARX  Input parameter file for eigenvalues &
c                              eigenvectors (unformatted)
c      prjnam : <dtflid>.PRJZ  Projection of the density matrix vector
c                              on the eigenvectors in diagonal space
c      ixnamx : <dtflid>.INDX  Basis index file in off-diag.
c      vtnamx : <dtflid>.STVX  Starting vector in off-diag.
c      egnam? : <dtflid>.EGV?  SLE eigenvalues/weights
c      evnam? : <dtflid>.EVC?  SLE eigenvectors
c
c----------------------------------------------------------------------
c
      character*30 ioflid,dtflid,ipname,mgname,rpname,vtnamx,
     #             egnamx,egnamy,egnamz,evnamx,evnamy,evnamz,
     #             prjnam,prnamx,prnamz,egnamo,evnamo,fidnam,
     #             ixnamx,datnam,gibnam
      logical nameOK
      integer namlth,nmlth1
c
      common /tdfnam/ nameOK,namlth,nmlth1,ioflid,dtflid,ipname,
     #      mgname,rpname,vtnamx,egnamx,egnamy,egnamz,evnamx,
     #      evnamy,evnamz,prjnam,prnamx,prnamz,egnamo,evnamo,
     #      fidnam,ixnamx,datnam,gibnam
c
      character*30 iofile,dtfile
c
      common /tdfile/ iofile(10),dtfile(10)
c
