c**********************************************************************
c       
c                       ===================
c                       SUBROUTINE : RDFDAT
c                       ===================
c
c       NOTE: This is the EPRLF version of subroutine RDDAT in
c       the EPRLL family of programs. 
c
c       This reads the parameters contained in the common block
c       defined in eprdat.inc into a file in a form that is written by
c       by wrfdat.f. 
c
c       Notes:
c               Care should be taken to ensure that the common 
c               block definition in the include file eprdat.inc
c               is consistent with the information stored in the
c               disk files by this routine to avoid corrupting 
c               the parameter file.
c
c       written by DJS 15-NOV-87
c       modified by DEB 13-MAR-92
c
c       Includes:
c               stdio.inc
c               eprdat.inc
c
c**********************************************************************
c
      subroutine rdfdat(prname,ierr)
c
      implicit none
c
      include 'stdio.inc'
      include 'eprdat.inc'
c
      character*30 prname
      integer i,j,ierr
c
c######################################################################
c
c----------------------------------------------------------------------
c     open parameter file
c----------------------------------------------------------------------
c
      ierr=0
      open (unit=ludisk,file=prname,status='old',
     #     access='direct',form='unformatted',recl=1024,err=9999)
      read (ludisk,rec=1,err=9998) 
     #        gxx,gyy,gzz,axx,ayy,azz,dx,dy,dz,tl,tkxy,tkzz,
     #        djf,djfprp,oss,psi,ald,bed,gad,alm,bem,gam,
     #        c20,c22,c40,c42,c44,bshift,wint0,wint2,
     #	      b0,gamman,fieldi,fieldf,cgtol,shiftr,shifti,
     #	      a0,g0,pl,pkxy,pkzz,zeen,(cxp(i),i=1,6),
     #        ((cpot(i,j),j=1,5),i=1,5),((xlk(i,j),j=1,5),i=1,5),
     #        (faa(i),i=1,5),(fgm(i),i=1,5),wtol
c
      read (ludisk,rec=2,err=9998)
     #        ((fam(i,j),i=1,2),j=1,5),((fgd(i,j),i=1,2),j=1,5),
     #        ((fad(i,j),i=1,2),j=1,5),t2edi,t2efi,t1edi,t1ndi,t2ndi,
     #        ptol,int1,stt1,nstp,in2,ipdf,ist,itype,ideriv,igsph,
     #        iasph,idrat,lemx,lomx,kmx,mmx,ipnmx,ips,jkmn,jmmn,
     #        nfield,nstep,mxcg,ipt,itd,itm,ipsi0,lband,kband,ldelta,
     #        kdelta,lkmdff,lkmtrc,lptmx,kptmx,ndim,neltot,nelv,nev,
     #        nevo,nelre,nelim,((ixp(i,j),i=1,6),j=1,2),
     #        (nmev(i),i=1,10),ngood,ndiag,ndimo,nort
c
c----------------------------------------------------------------------
c     close parameter file
c----------------------------------------------------------------------
c
      close (unit=ludisk)
      return
c
c----------------------------------------------------------------------
c  Error return: 1 -> open error
c                2 -> read error
c                3 -> not an EPRLF version 1.2 file
c----------------------------------------------------------------------
c
 9998 ierr=ierr+1
      close (unit=ludisk)
 9999 ierr=ierr+1
      return
      end
