c**********************************************************************
c       
c                       ===================
c                       SUBROUTINE : WRFOUT
c                       ===================
c
c       NOTE: This is the EPRTD version of subroutine WRFOUT.
c
c       This writes the parameters and file names in a log file.
c
c       Includes:
c               stdio.inc
c               tdexp.inc
c               tdfnam.inc
c
c**********************************************************************
c
      subroutine wrfout(lu)
c
      implicit none
c
      include 'stdio.inc'
      include 'tdexp.inc'
      include 'tdfnam.inc'
c
      integer lu
c
c######################################################################
c
      write(lu,1000) ipname(:namlth)
c
      write (lu,2000) iexp
      write (lu,2005) icomb
      write (lu,2010) npt1,npt2
      write (lu,2020) idtf,ispc
      if (idtf.eq.0) then
          write (lu,2030) init1,stpt1,init2,stpt2
      else if (idtf.eq.1) then
          write (lu,2035) init1,stpt1,inif2,finf2
      else
          write (lu,2040) inif1,finf1,inif2,finf2
      end if
      if (iexp.gt.2) write (lu,2050) tfix
      write (lu,2060) ndim1
      if (iexp.lt.3) then
          write (lu,2070) nev1
      else
          write (lu,2075) nev1,nev0
      end if
      write (lu,2080) inz
      write (lu,2090) field
c
      write (lu,2110) gib0,gib2
      write (lu,2200) lwid
c
      return
c
c======================================================================
c     format statements
c======================================================================
c
 1000 format(/,2x,22('#'),3x,'input file : ',a,3x,22('#'),/)
 2000 format(2x,'experimental type [iexp] : ',i1,/,5x,
     #     '(0-FID,1-COSY,2-SECSY,3-ELDOR,4-E.ELDOR,5-S.SECSY)')
 2005 format(2x,'spectral combination (Sc+ or Sc-) [icomb] : ',i2)
 2010 format(2x,'# of data pts in 2D exp. [npt1,npt2] : ',i3,2x,i3)
 2020 format(2x,'calculation and output type [idtf,ispc] : ',i2,2x,i2,
     #    /,10x,'0 --> (t1,t2) ; 1 --> (t1,f2) ; 2 --> (f1,f2)')
 2030 format(2x,'axes range in (t1,t2) (ns) [init1,stpt1,',
     #     'init2,stpt2] : ',/,15x,f6.1,3(2x,f6.1))
 2035 format(2x,'axes range in (t1,f2) (ns,MHz) [init1,stpt1,',
     #     'inif2,finf2] : ',/,15x,f6.1,2x,f6.1,2x,f8.2,2x,f8.2)
 2040 format(2x,'axes range in (f1,f2) (MHz) [inif1,finf1,',
     #     'inif2,finf2] : ',/,15x,f8.2,3(2x,f8.2))
 2050 format(2x,'fixed time interval [tfix] : ',g13.6)
 2060 format(2x,'dimension of SLE matrix in pS=1 space [ndim1]',
     #     ' : ',i5)
 2070 format(2x,'# of sig. egv in off-diag. space [nev1] : ',i5)
 2075 format(2x,'# of sig. egv in off-diag. & diag. space [nev1,nev0]',
     #     ' : ',i5,2x,i5)
 2080 format(2x,'nuclear Zeeman included? [inz] : ',i1)
 2090 format(2x,'magnetic field [field] : ',g10.2)
c
 2110 format(2x,'Gaussian inho. broad. width (gauss) [gib0,gib2] : ',
     #     g10.2,1x,g10.2)
 2200 format(2x,'Homogeneous line-width (gauss) [lwid] : ',g10.2)
c
      end
