c----------------------------------------------------------------------
c                         ====================
c                          common block EXPDAT
c                         ====================
c     Experimental data used for least-squares fitting and associated
c     parameters.  It also keeps the variable in series option.
c
c     NOTE: File 'nlsdim.inc' should be included before this file
c           in the program source code.
c
c  ** User-specified parameters **
c
c    *Set by data command
c     data           : Experimental data array
c     idepnd         : Dependency flag for scale factor (sfac)
c     sishft         : shift flag
c
c    *Set by series command
c     siexp          : Experimental type (0=FID, 1=COSY, 2=SECSY, 3=ELDOR
c                                         4=Echo-ELDOR, 5=Stim. SECSY)
c     sicomb         : Spectral combination
c     snpt1,snpt2    : Number of data points in t1 & t2
c     sinit1,sstept1 : Initial and step values in t1 (ns)
c     sinit2,sstept2 : Initial and step values in t2 (ns)
c     stfix          : Fixed time (mixing time in ELDOR)
c
c  ** parameters calculated during fit **
c
c     cwdata         : cw-equivalent spectra extracted from 2D data array
c     sfac           : Scale factor for each spectrum in series option
c     sshft          : Field offset (shift spectrum)
c     ndata          : Number of data points in each spectrum
c     ixsp           : Starting index of each spectrum in data array
c     ixspcw         : Starting index for cw-eq. spectrum in cwdata array
c     nspc           : Number of spectra
c     nptot          : Total number of points (all spectra)
c     nptotcw        : Total number of cw data points (all spectra)
c     dataid         : Identification string for each data file
c     sratio         : scaling ratio for each independent experimental
c                      spectrum to have same maximum intensity
c
c----------------------------------------------------------------------
      character dataid*30,wndoid*20
      integer siexp,sicomb,snpt1,snpt2,ndata,ixsp,ixspcw,idepnd,
     #        sishft,nspc,nptot,nptotcw
      double precision data,cwdata,sinit1,sstept1,sinit2,sstept2,
     #                 stfix,sfac,sshft,sratio
c
      common /expdat/ data(mxpt),cwdata(mxnpt*mxspc),sinit1(mxspc),
     #        sstept1(mxspc),sinit2(mxspc),sstept2(mxspc),
     #        stfix(mxspc),sfac(mxspc),sshft(mxspc),sratio(mxspc),
     #        siexp(mxspc),sicomb(mxspc),snpt1(mxspc),snpt2(mxspc),
     #        ndata(mxspc),ixsp(mxspc),ixspcw(mxspc),idepnd(mxspc+1),
     #        sishft(mxspc),nspc,nptot,nptotcw,dataid(mxspc),
     #        wndoid(mxspc)
c
