c  VERSION 1.0  (NLS version)   4/10/93
c*********************************************************************
c
c                       ===================
c                       SUBROUTINE : STVECD
c                       ===================
c
c     This subroutine calculates the starting vector for the diagonal
c     space, which is used to obtain the weighting factors of diagonal
c     eigenvectors.  It is intended for use with nonlinear lease-squares
c     applications.
c
c     On Entry :
c        evalx : eigenvalues of the off-diagonal space
c        evevx : eigenvectors of the off-diagonal space
c
c        Other parameters are passed through common block /eprprm/.
c
c     On Exit  :
c        stvd  : starting vector for diagonal space returned through
c                the common block /stvcom/
c
c     10-APR-93 Sanghyuk Lee
c
c     Includes :
c        nlsdim.inc
c        eprprm.inc
c        stvcom.inc
c        wkspcm.inc
c
c*********************************************************************
c
      subroutine stvecd(evalx,evecx,npt)
c
      implicit none
c
      include 'nlsdim.inc'
      include 'eprprm.inc'
      include 'stvcom.inc'
      include 'wkspcm.inc'
c
      integer i,j,nt1,npt
      double precision t1,cfact
c
      complex*16 czero
      parameter (czero=(0.0D0,0.0D0))
c
      complex*16 evalx,evecx
      dimension evalx(mxegv),evecx(mxdim,mxegv)
c
c#####################################################################
c
      cfact=1.760844783D1
c
      do 10 i=1,nevo
         cwsp1(i)=czero
         do 20 j=1,ndimo
 20         cwsp1(i)=cwsp1(i)+evecx(j,i)*stvo(j)
 10   continue
c
      do 40 nt1=1,npt
         t1=(init1+(nt1-1)*stept1)*cfact*1.0D-3
c
         do 50 i=1,nevo
 50         cwsp2(i)=cdexp(-evalx(i)*t1)
c
         do 60 i=1,ndimo
            stvd(i,nt1)=czero
            do 70 j=1,nevo
 70            stvd(i,nt1)=stvd(i,nt1)+evecx(i,j)*cwsp2(j)*cwsp1(j)
 60      continue
c
 40   continue
c
      return
      end

